Description

This is a guide for installing the Linux-ck kernel on Arch linux.

Prepare the Environment

o Make sure the system is up to date:

sudo pacman -Syu

Install Linux-ck from Repo-ck

e Edit the pacman.conf:

vi /etc/pacman.conf

o And add the following to the end of the file:

[repo-ck]

Server = http://repo-ck.com/$arch
Server = http://repo-ck.com/$arch
Server = http://repo-ck.com/$arch
Server = http://repo-ck.com/$arch
Server = http://repo-ck.com/$arch

* Now repo key needs to be received and locally signed:

pacman—-key —-r 5EE46C4C
pacman—-key —--lsign-key 5EE46C4C

® Refresh the repo metadata:

pacman -Sy
e (Optional) Identify the CPU:

gcc —-¢ —Q —march=native --help=target | grep march
e |nstall the generic Linux-ck kernel:

pacman -S linux-ck-generic
o (Optional) Or install the CPU specific kernel:

pacman —-S linux-ck-kx

¢ |nstall the generic Linux-ck kernel headers:

pacman —-S linux-ck-generic-headers

o (Optional) Or install the CPU specific kernel:

pacman —-S linux—-ck-kx

Install nVidia driver

e |nstall the generic Linux-ck nVidia driver:

pacman —-S nvidia-304xx-ck—-generic

o (Optional) Or install the CPU specific nVidia driver:

pacman -S nvidia-304xx-ck-kx

Install VirtualBox host driver:

e [nstall the generic Linux-ck VirtualBox host driver:

pacman -S virtualbox-ck-host-modules-generic

o (Optional) Or install the CPU specific VirtualBox host driver:

pacman -S virtualbox-ck-host-modules-kx

e Update the grub config:

grub-mkconfig -o /boot/grub/grub.cfg

Install Linux-ck from the AUR
Install yaourt

e Install yaourt
Receive PGP keys

¢ Receive Linus Torvalds' PGP key:

gpg —--recv-keys 79BE3E4300411886

o Then utimately trust the key:

trust
https://project.altservice.com/issues/509

5

VY]
quit

* Receive Greg Kroah-Hartman's PGP key:

gpg ——recv-keys 38DBBDC86092693E

o Then ultimately trust the key:

trust
5

Ny
quit

Install Linux-ck kernel

e |nstall the linux-ck package from the AUR:

yaourt linux-ck

o (Optional) Install the linux-ck-headers package:
yaourt linux-ck-headers
e Edit the PKGBUILD file and add the following:
_BFQ_enable_="y"
e Update the grub config:

grub-mkconfig -o /boot/grub/grub.cfg

Install Linux-ck nVidia driver

e (Optional) Install the linux-ck nvidia package:

yaourt nvidia-304xx-ck

Install Linux-ck VirtualBox host driver

e (Optional) Install the linux-ck virtualbox host modules:

yaourt virtualbox-ck-host-modules

Enable Budget Fair Queueing (BFQ) I/O Scheduling

e Check which I/0O scheduler is in use:

cat /sys/block/sda/queue/scheduler
o Example output:

noop deadline [cfqg] bfg

e Enable BFQ on /dev/sda without rebooting:

echo bfg > /sys/block/sda/queue/scheduler

e Check which I/0O scheduler is in use:

cat /sys/block/sda/queue/scheduler

o Example output:

noop deadline cfqg [bfqg]

e Use BFQ on /dev/sda at boot persistently, create the set_|O_scheduler.conf file:

sudo vi /etc/tmpfiles.d/set_IO_scheduler.conf

o And add the following:

w /sys/block/sda/queue/scheduler - - - - bfqg

BFQ Script

| had problems getting the tmpfiles.d configuration to work properly on systemd 219, so | created a script to easily enable BFQ on
/dev/sda.

e Create the enable-bfg.sh script:

sudo nano /usr/local/sbin/enable-bfg.sh

o And add the following:

#!/bin/sh
## Script to enable BFQ on /dev/sda
echo bfg > /sys/block/sda/queue/scheduler

e Make it executable:

sudo chmod +x /usr/local/sbin/enable-bfqg.sh

Resources

https://wiki.archlinux.org/index.php/Kernels

https://wiki.archlinux.org/index.php/Linux-ck

https://wiki.archlinux.org/index.php/Repo-ck
https://wiki.archlinux.org/index.php/Linux-ck#How_to_enable_the BFQ_|.2FO_Scheduler
https://wiki.archlinux.org/index.php/Kernels
https://wiki.archlinux.org/index.php/Linux-ck
https://wiki.archlinux.org/index.php/Repo-ck
https://wiki.archlinux.org/index.php/Linux-ck#How_to_enable_the_BFQ_I.2FO_Scheduler

History

#1 - 05/25/2015 11:54 AM - Daniel Curtis
- Description updated
- % Done changed from 0 to 10

#2 - 05/26/2015 11:03 AM - Daniel Curtis
- % Done changed from 10 to 20

- Description updated

#3 - 06/03/2015 04:33 PM - Daniel Curtis
- Description updated
- Status changed from New to In Progress

- % Done changed from 20 to 50

#4 - 06/03/2015 04:49 PM - Daniel Curtis

- Description updated

#5 - 06/03/2015 04:55 PM - Daniel Curtis

- Description updated

- Status changed from In Progress to Resolved

- % Done changed from 50 to 100

#6 - 06/03/2015 05:07 PM - Daniel Curtis

- Description updated

#7 - 06/03/2015 05:07 PM - Daniel Curtis

- Description updated

#8 - 06/04/2015 11:28 AM - Daniel Curtis

- Description updated

#9 - 06/08/2015 09:58 AM - Daniel Curtis

- Description updated

#10 - 06/12/2015 10:31 AM - Daniel Curtis

- Status changed from Resolved to Closed

#11 - 07/15/2016 07:41 PM - Daniel Curtis

- Description updated
